------------------------------------------------------
-- Aysel Karimova								                    --
-- SMALLSAT master thesis-PCA jacobi	   			      --
-- Supervisors: Kjetil Svarstad, Milica Orlandic    --
-- NTNU-EMECS  2018									                --
-- Choosing (p,q) for cyclic Jacobi				          --
------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity choose_pq is
	generic (
		constant matrix_size	: positive := 100	
	);
	port (
		clock	: in std_logic;
		reset	: in std_logic;
		enable: in std_logic;
		p_out	: out natural range 0 to matrix_size-1;
		q_out	: out natural range 0 to matrix_size-1
	);
end choose_pq;

architecture rtl_pq of choose_pq is

	signal p_temp	: natural range 0 to matrix_size-1;
	signal q_temp	: natural range 0 to matrix_size-1;

begin

	p_out <= p_temp;
	q_out <= q_temp;
	
	path: process(reset, clock)
	begin
		if reset = '1' then
			p_temp <= 0;
			q_temp <= 1;
		else
			if clock'event and clock = '1' then
				if enable = '1' then
					if((p_temp = matrix_size-2)and(q_temp = matrix_size-1))then
						p_temp <= 0;
						q_temp <= 1;
					elsif(q_temp < matrix_size-1) then
						q_temp <= q_temp + 1;
					elsif(q_temp = matrix_size-1) then
						p_temp <= p_temp + 1;
						q_temp <= p_temp + 2;
					end if;
				end if;
			end if;
		end if;
	end process path;	
end rtl_pq;